<script setup lang="ts">
import FontAwesomeIcon from "@/components/FontAwesomeIcon.vue";
import MarkdownRenderer from "@/components/MarkdownRenderer.vue";
import type {
  FlatWorkflowParameters,
  TemporaryParams,
} from "@/types/WorkflowParameters.ts";
import { computed } from "vue";
import { flattenParameters } from "@/utils/Workflow.ts";
import type { RouteLocationRaw, RouteParamsRaw } from "vue-router";

const props = defineProps<{
  loading?: boolean;
  parameters: TemporaryParams;
}>();

const emit = defineEmits<{
  (e: "link-clicked", route: RouteLocationRaw): void;
}>();

const flatParameters = computed<FlatWorkflowParameters | undefined>(() => {
  if (props.parameters.params == undefined) {
    return undefined;
  }
  return flattenParameters(flattenParameters(props.parameters.params));
});

// eslint-disable-next-line @typescript-eslint/no-explicit-any
function isBucketLink(value: any): boolean {
  if (typeof value === "string") {
    return value.startsWith("s3://");
  }
  return false;
}

function getS3LinkParameters(s3String: string): RouteParamsRaw {
  const pathComponents = s3String.slice(5).split("/");
  const s3File =
    pathComponents.length > 1 &&
    pathComponents[pathComponents.length - 1].includes(".");
  return {
    bucketName: pathComponents[0],
    subFolders: pathComponents.slice(1, s3File ? -1 : undefined),
  };
}

const logs_s3_path = computed<string | undefined>(
  () => props.parameters.metaParams?.logs_s3_path ?? undefined,
);
const debug_s3_path = computed<string | undefined>(
  () => props.parameters.metaParams?.debug_s3_path ?? undefined,
);
const provenance_s3_path = computed<string | undefined>(
  () => props.parameters.metaParams?.provenance_s3_path ?? undefined,
);
const notes = computed<string | undefined>(
  () => props.parameters.metaParams?.notes ?? undefined,
);
</script>

<template>
  <table class="table table-hover">
    <caption class="placeholder-glow">
      <span v-if="loading" class="placeholder col-1"></span>
      <template v-else>
        {{ Object.keys(flatParameters ?? {}).length }}
      </template>
      Parameters
    </caption>
    <tbody>
      <template v-if="loading">
        <tr v-for="n in 5" :key="n">
          <th scope="row" style="width: 20%" class="placeholder-glow">
            <div class="placeholder col-12"></div>
          </th>
          <td class="placeholder-glow">
            <div class="placeholder col-8"></div>
          </td>
        </tr>
      </template>
      <template v-else>
        <tr v-if="notes">
          <th scope="row" class="text-end"><b>notes</b></th>
          <th>
            <markdown-renderer :markdown="notes" />
          </th>
        </tr>
        <tr
          v-if="logs_s3_path"
          :class="{
            'border-bottom-thick': !debug_s3_path && !provenance_s3_path,
          }"
        >
          <th scope="row" style="width: 10%" class="text-end">
            <b>logs</b>
          </th>
          <td>
            <router-link
              :to="{
                name: 'bucket',
                params: getS3LinkParameters(logs_s3_path),
              }"
              @click.prevent="
                emit('link-clicked', {
                  name: 'bucket',
                  params: getS3LinkParameters(logs_s3_path),
                })
              "
              >{{ logs_s3_path }}
            </router-link>
          </td>
        </tr>
        <tr
          v-if="provenance_s3_path"
          :class="{
            'border-bottom-thick': !debug_s3_path,
          }"
        >
          <th scope="row" style="width: 10%" class="text-end">
            <b>provenance</b>
          </th>
          <td>
            <router-link
              :to="{
                name: 'bucket',
                params: getS3LinkParameters(provenance_s3_path),
              }"
              @click.prevent="
                emit('link-clicked', {
                  name: 'bucket',
                  params: getS3LinkParameters(provenance_s3_path),
                })
              "
              >{{ provenance_s3_path }}
            </router-link>
          </td>
        </tr>
        <tr v-if="debug_s3_path" class="border-bottom-thick">
          <th scope="row" style="width: 10%" class="text-end">
            <b>debug</b>
          </th>
          <td>
            <router-link
              :to="{
                name: 'bucket',
                params: getS3LinkParameters(debug_s3_path),
              }"
              @click.prevent="
                emit('link-clicked', {
                  name: 'bucket',
                  params: getS3LinkParameters(debug_s3_path),
                })
              "
              >{{ debug_s3_path }}
            </router-link>
          </td>
        </tr>
        <tr v-for="(value, name) in flatParameters" :key="name">
          <th scope="row" class="text-end">
            <b>{{ name.replace(/\./g, ".\u200B") }}</b>
          </th>
          <td>
            <router-link
              v-if="typeof value === 'string' && isBucketLink(value)"
              :to="{
                name: 'bucket',
                params: getS3LinkParameters(value),
              }"
              @click.prevent="
                emit('link-clicked', {
                  name: 'bucket',
                  params: getS3LinkParameters(value),
                })
              "
              >{{ value }}
            </router-link>
            <a
              v-else-if="typeof value === 'string' && value.startsWith('http')"
              :href="value"
              target="_blank"
              >{{ value }}
              <font-awesome-icon
                icon="fa-solid fa-arrow-up-right-from-square"
                class="ms-1"
              />
            </a>
            <template v-else>{{ value }}</template>
          </td>
        </tr>
      </template>
    </tbody>
  </table>
</template>

<style scoped>
.border-bottom-thick {
  border-bottom: 3px var(--bs-border-style) var(--bs-border-color) !important;
}
</style>
